import { Component, OnInit, ViewChild } from '@angular/core';
import { Router } from '@angular/router';
import { STComponent, STColumn, STChange } from '@delon/abc/st';
import { SFComponent, SFSchema, SFDateWidgetSchema } from '@delon/form';
import { NzModalService } from 'ng-zorro-antd/modal';
import { SystemService } from 'src/app/routes/sys-setting/services/system.service';

@Component({
  selector: 'app-freight-account',
  templateUrl: './freight-account.component.html',
  styleUrls: ['./freight-account.component.less']
})
export class FreightAccountComponent implements OnInit {
  @ViewChild('accountModal', { static: true })
  accountModal: any;
  @ViewChild('st', { static: true })
  st!: STComponent;
  @ViewChild('sf', { static: false })
  sf!: SFComponent;

  url = `/rule?_allow_anonymous=true`;

  searchSchema: SFSchema = {
    properties: {
      expand: {
        type: 'boolean',
        ui: {
          hidden: true
        }
      },
      receiveName: {
        type: 'string',
        title: '企业名称',
        ui: { placeholder: '请输入' }
      },
      phone: {
        type: 'string',
        title: '联系人',
        ui: { placeholder: '请输入' }
      },
      page: {
        type: 'string',
        title: '联系人电话',
        ui: {
          placeholder: '请输入'
        }
      },
      createTime: {
        title: '创建时间',
        type: 'string',
        ui: {
          widget: 'date',
          mode: 'range',
          format: 'yyyy-MM-dd',
          visibleIf: {
            expand: (value: boolean) => value
          }
        } as SFDateWidgetSchema
      },
      receiveName2: {
        type: 'string',
        title: '无车承运人',
        enum: [{ label: '全部', value: '全部' }],
        ui: {
          widget: 'select',
          placeholder: '请选择',
          change: (i: any) => {
            this.sf.value.receiveName2 = i;
            this.sf?.setValue('/receiveName2', i);
          },
          visibleIf: {
            expand: (value: boolean) => value
          }
        }
      }
    }
  };

  columns: STColumn[] = [
    { title: '企业名称', index: 'description' },
    { title: '统一社会信用代码', index: 'description' },
    { title: '联系人', index: 'description' },
    { title: '联系人电话', index: 'description' },
    { title: '累计消费金额', index: 'description' },
    { title: '账户余额', render: 'description1' },
    { title: '创建时间', index: 'updatedAt', type: 'date' },
    {
      title: '操作',
      buttons: [
        {
          text: '查看明细',
          click: item => this.routeTo(item)
        }
      ]
    }
  ];
  selectedRows: any[] = [];

  reqParams = { pageIndex: 1, pageSize: 10 };
  _$expand = false;

  accountList = [{ description: 222 }, { description: 222 }, { description: 222 }];
  constructor(public service: SystemService, private nzModalService: NzModalService, private router: Router) {}

  ngOnInit(): void {}

  stChange(e: STChange): void {
    switch (e.type) {
      case 'checkbox':
        this.selectedRows = e.checkbox!;
        break;
      case 'filter':
        this.st.load();
        break;
    }
  }

  showAccount(item: any) {
    const modal = this.nzModalService.create({
      nzTitle: '账户明细',
      nzContent: this.accountModal,
      nzFooter: []
    });
    modal.afterClose.subscribe(res => {
      this.st.load();
    });
  }

  routeTo(item?: any) {
    this.router.navigate(['/financial-management/freight-account-detail/1']);
  }

  /**
   * 重置表单
   */
  resetSF() {
    this.sf.reset();
    this._$expand = false;
  }

  /**
   * 伸缩查询条件
   */
  expandToggle() {
    this._$expand = !this._$expand;
    this.sf?.setValue('/expand', this._$expand);
  }
}
